import Graphics.UI.Yahu

{- PROPSITO DEL EJEMPLO:
			- MOSTRAR EL FUNCIONAMIENTO DE UN Dialog

A travs de un dilogo elegimos si queremos pintar o no un crculo
-}

main = yahu init
  where init = do {
    ; win <- window [title =: "dibujo a la carta"]
    ; cnv <- canvas [dim =: size 200 200] win
    ; win!:layout =: cnv
    -- por defecto el dilogo devuelve la accin nula (return ())
    -- tipo: diag :: Dialog (IO ())
    ; diag <- dialog [title =: "elija...", value =: (return ())] win
    -- pulsando este botn pintaremos un crculo en el canvas
    ; bot1 <- button [text =: "circulo", command =: do {
    	; diag!:value =: drawCircle cnv (point 100 100) 100
    	; endModal diag
    	} ] diag
    -- pulsando este botn no haremos nada
    ; bot2 <- button [text =: "nada", command =: endModal diag] diag
    ; diag!:layout =: bot1 ^*^ bot2
    -- activamos el dilogo *modal* (el flujo normal del programa se detiene)
    ; pintar <- showModal diag
    {- ejecutamos la accin devuelta por el dilogo. Igual hubiera podido tener el tipo
    (Dialog Bool), y entonces escribiramos
	  main = yahu init
  	   where init = do {
    	; win <- window [title =: "dibujo a la carta"]
    	; cnv <- canvas [dim =: size 200 200] win
	    ; win!:layout =: cnv
    	; diag <- dialog [title =: "elija...", value =: False] win
    	; bot1 <- button [text =: "circulo", command =: do {
    		; diag!:value =: True
    		; endModal diag
    		} ] diag
    	; bot2 <- button [text =: "nada", command =: endModal diag] diag
    	; diag!:layout =: bot1 ^*^ bot2
    	; pintar <- showModal diag
    	; if pintar then drawCircle cnv (point 100 100) 100 else return ()
    -}
    ; pintar
    }