import Graphics.UI.Yahu

{- PROPSITO DEL EJEMPLO
			- MOSTRAR LA FORMA DE USO DE Entry
			- MOSTRAR LA POSIBILIDAD DE AADIR OBJETOS DINMICAMENTE
			- MOSTRAR LA POSIBILIDAD DE CAMBIAR MANEJADORES DE EVENTOS DENTRO DE LOS MISMOS

En este ejemplo veremos cmo leer valores parseados a partir de un Entry. En el Entry
se escribir un nmero que indicar cuntos botones adicionales se quiere crear.
-}

main = yahu init
 where init = do {
	; win <- window [title =: "ejemplo de Entry"]
	; etq <- label [text =: "Introduzca el nmero de botones adicionales:"] win
	; (entrada {- ::Entry Int -} ) <- entry [] win
	; win!:layout =: etq ^*^ entrada
	-- el evento "action" de un Entry se produce al pulsar Enter mientras se edita
	; entrada!:command =: do {
	  ; quizas <- entrada?:safeValue
	  ; case quizas of
	      Nothing -> entrada!:text =: "Introduza un valor numrico entero"
	      Just numbotones -> if numbotones>0 then do {
	      		-- generamos una lista con la cantidad de botones especificada
	      		; botones <- mapM (\n-> button [text =: ("botn "++show n)] win) [1..numbotones]
	      		; etq!:text =: "hecho"
	      		-- deshabilitamos el manejador de evento sustituyndolo por la accin nula
	      		; entrada!:command =: (return ())
	      		; entrada!:text =: "accin deshabilitada"
	      		; chk <- checkBox [text =: "de propina", isChecked =: True] win
	      		; win!:layout =: etq ^*^ entrada ^*^ lVertical (map expand botones) ^*^ chk
	      		}
	      	else
	      		entrada!:text =: "Introduzca un nmero mayor que 0"
	  }
	}
