import Graphics.UI.Yahu

{- PROPSITO DEL EJEMPLO:
			- EJEMPLO BSICO DE MENS

Proporcionar un ejemplo de cmo se crean y usan mens
-}

{----------------------------------------------------------------------------------------}

main = yahu init
 where init = do {

 	; win <- window [title =: "ejemplo de mens", statusBar =: [VL 1]]

 	--ejemplificacion de cmo se insertan mens y menuitems. En el caso de los InBarMenu,
 	--insertamos al menos uno antes que cualquier hijo Widget del Window porque si no se
 	--interacciona indeseablemente con el algortimo de layout, de forma que se le asigna
 	--al Window un tamao mnimo muy superior al posible
 	
 	--aadimos un men a la barra de mens
 	; menu1 <- inBarMenuAppend [title =: "&men 1"] win
 	; let genmenu1 = MnInBar menu1
 	--insertamos en la posicin 0 (al principio) un submen al men anterior
 	; submenu <- subMenu 0 [text =: "submen"] genmenu1
 	; let gensubmenu = MnSub submenu
 	--aadimos un separador
 	; menuSeparatorAppend gensubmenu
 	--insertamos un item en la posicin 0
 	; menuLabel 0 [text =: "item de men", statusBarHelp =: "esto es un MenuLabel"] gensubmenu
 	--insertamos un item chqueable en la posicin 2
 	; menuCheck 2 [text =: "item checkable", statusBarHelp =: "esto es un MenuCheck"] gensubmenu
 	--insertamos en la posicin 0 de la barra de mens otro men
 	; menu2 <- inBarMenu 0 [title =: "me&n vaco"] win

	--sujeto de pruebas
 	; pruebas <- edit [text =: "sujeto de experimentacin"] win
 	
 	--men pop-up: muestra de cmo usar los eventos "action" (on action == command)
 	; popup <- popupMenu
 	; let genpopup = MnPopup popup
 	--aadimos un item que al ser pinchado escribe "MenuLabel" en "pruebas"
 	; menuLabelAppend [text =: "esto es un Menu&Label inserto en un PopupMenu"
 		, command =: writeText pruebas "MenuLabel"] genpopup
	--aadimos un separador
	; menuSeparatorAppend genpopup
 	--aadimos un item chqueable que al ser pinchado escribe su nuevo estado en "pruebas"
 	; chk <- menuCheckAppend [text =: "esto es un Menu&Check inserto en un PopupMenu"] genpopup
 	; chk!:command =: ((chk?:isChecked) >>= (writeText pruebas).show)
 	
 	--al pinchar con el botn derecho en la ventana o en la etiqueta, desplegamos el men pop-up
 	; let popupevent obj =
 		obj!:on (right mouse) =: \MouseEvent{mousePoint=pos}-> do {
 			; showPopupMenu popup pos obj
 			; return True
 			}
 	; popupevent win
 	; popupevent pruebas

 	--un men pop-up puede ser mostrado en cualquier ventana de aplicacin existente
 	; win2 <- window [title =: "otra ventana", dim =: size 80 80]
 	; popupevent win2

 	; win!:layout =: floating pruebas
 	; win!:dimX =: 400
 	}
